---
title: aspect-ratio
slug: Web/CSS/@media/aspect-ratio
tags:
  - '@media'
  - CSS
  - Media Queries
  - Reference
  - media feature
---
<div>{{cssref}}</div>

<p>The <strong><code>aspect-ratio</code></strong> <a href="/en-US/docs/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#Media_features">media feature</a> can be used to test the aspect ratio of the {{glossary("viewport")}}.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>aspect-ratio</code> feature is specified as a {{cssxref("&lt;ratio&gt;")}} value representing the width-to-height aspect ratio of the viewport. It is a range feature, meaning you can also use the prefixed <strong><code>min-aspect-ratio</code></strong> and <code><strong>max-aspect-ratio</strong></code> variants to query minimum and maximum values, respectively.</p>

<h2 id="Examples">Examples</h2>

<p>The example below is contained in an {{htmlElement("iframe")}}, which creates its own viewport. Resize the <code>&lt;iframe&gt;</code> to see <code>aspect-ratio</code> in action.</p>

<p>Note that, when none of the media query conditions are true, the background will turn white because none of the below rules will be applied to the <code>&lt;div&gt;</code> inside the <code>&lt;iframe&gt;</code>. See if you can find which width and height values trigger this!</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div id='inner'&gt;
  Watch this element as you resize your viewport's width and height.
&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">/* Minimum aspect ratio */
@media (min-aspect-ratio: 8/5) {
  div {
    background: #9af; /* blue */
  }
}

/* Maximum aspect ratio */
@media (max-aspect-ratio: 3/2) {
  div {
    background: #9ff;  /* cyan */
  }
}

/* Exact aspect ratio, put it at the bottom to avoid override*/
@media (aspect-ratio: 1/1) {
  div {
    background: #f9a; /* red */
  }
}
</pre>

<div class="hidden">
<h2 id="_Example">_Example</h2>

<p>used iframe and DataURL to enable this iframe could resize</p>

<h3 id="HTML_2">HTML</h3>

<pre class="brush: html notranslate">&lt;label id="wf" for="w"&gt;width:165&lt;/label&gt;
&lt;input id="w" name="w" type="range" min="100" max="250" step="5" value="165"&gt;
&lt;label id="hf" for="w"&gt;height:165&lt;/label&gt;
&lt;input id="h" name="h" type="range" min="100" max="250" step="5" value="165"&gt;

&lt;iframe id="outer" src="data:text/html,&lt;style&gt; @media (min-aspect-ratio: 8/5) { div { background: %239af; } } @media (max-aspect-ratio: 3/2) { div { background: %239ff; } } @media (aspect-ratio: 1/1) { div { background: %23f9a; } }&lt;/style&gt;&lt;div id='inner'&gt; Watch this element as you resize your viewport's width and height.&lt;/div&gt;"&gt;

&lt;/iframe&gt;
</pre>

<h3 id="CSS_2">CSS</h3>

<pre class="brush: css notranslate">iframe{
  display:block;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">outer.style.width=outer.style.height="165px"

w.onchange=w.oninput=function(){
  outer.style.width=w.value+"px"
  wf.textContent="width:"+w.value
}
h.onchange=h.oninput=function(){
  outer.style.height=h.value+"px"
  hf.textContent="height:"+h.value
}</pre>
</div>

<h3 id="Result">Result</h3>

<div style="overflow: auto;">
<p>{{ EmbedLiveSample('_Example', '300px', '400px') }}</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Media Queries', '#aspect-ratio', 'aspect-ratio')}}</td>
   <td>{{Spec2('CSS4 Media Queries')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Media Queries', '#aspect-ratio', 'aspect-ratio')}}</td>
   <td>{{Spec2('CSS3 Media Queries')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.at-rules.media.aspect-ratio")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">Using Media Queries</a></li>
 <li><a href="/en-US/docs/Web/CSS/@media">@media</a></li>
</ul>
